
Public Const verbI=1
Public Const verbYou=2
Public Const verbHSI=3
Public Const verbWe=4
Public Const verbThey=5

'time constants
Public Const verbPrSimp=100
Public Const verbPrCont=101
Public Const verbPrPerf=102
Public Const verbPtSimp=103
Public Const verbPtCont=104
Public Const verbPtPerf=105
Public Const verbFtSimp=106
Public Const verbFtCont=107

'modal verb constants
Public Const verbMust=1000
Public Const verbHaveTo=1001
Public Const verbCan=1002
Public Const verbCould=1003
Public Const verbWdLikeTo=1004
Public Const verbWantTo=1005


Class Sentence
	Dim aNoun,aVerb
	Dim anAdv
	Dim intTime
	Dim blPositive
	Dim strAddition

	Function Instantiate(a1,a2,a3,a4,a5,a6)
		On Error Resume Next
		Set aNoun=New Noun
		Set aNoun=a1
		Set aVerb=New Verb
		Set aVerb=a2
		Set anAdv=New Adverb
		Set anAdv=a3
		strAddition=a4
		intTime=a5
		blPositive=a6
		Instantiate=True
	End Function

	Function Compose
		On Error Resume Next
		Dim strV,str1
		If UCase(aNoun.strNoun)="I" Then
			strV=aVerb.SpecialForm(verbI,intTime,blPositive)
		ElseIf UCase(aNoun.strNoun)="YOU" Then
			strV=aVerb.SpecialForm(verbYou,intTime,blPositive)
		ElseIf Ucase(aNoun.strNoun)="WE" Then
			strV=aVerb.SpecialForm(verbWe,intTIme,blPositive)
		ElseIf UCase(aNoun.strNoun)="THEY" Or UCase(aNoun.strNoun)=UCase(aNoun.strPlural) Then
			strV=aVerb.SpecialForm(verbThey,intTime,blPositive)
		Else
			strV=aVerb.SpecialForm(verbHSI,intTime,blPositive)
		End If

		str1=UCase(strAddition)
		If aVerb.blAfter And ((str1="ME") Or (str1="IT") Or (str1="YOU") Or (str1="US") Or (str="THEM")) Then strV=strV & " " & strAddition & " " & aVerb.strAfter Else strV=strV & " " & aVerb.strAfter & " " & strAddition
		Compose=aNoun.strNoun & " " & strV & " " & anAdv.strAdverb
	End Function
End Class

Class Verb
	Dim strVerb,strAfter,strHSIForm
	Dim strForm1,strForm2 'Partizip II
	Dim strForm3 'ing- form
	Dim blTransitive,blAfter

	Function Instantiate(strParam)
		'strParam looks like: (<vt|vi>)<verb>,<HSIform>,<form1>,<form2>,<ing- form>
		'for example, (vt)have,has,had,had;(vi)go,goes,went,gone,going
		On Error Resume Next
		
		Dim strEd,strCh,i
		strEd=Trim(strParam)
		strEd=LCase(strEd)
		If Mid(strEd,2,1)<>"v" Then
			Instantiate=False
			Exit Function
		End If
		If Mid(strEd,3,1)="t" Then blTransitive=True Else blTransitive=False
		strVerb=""
		strHSIForm=""
		strForm1=""
		strForm2=""
		i=5
		While Mid(strEd,i,1)<>","
			strVerb=strVerb & Mid(strEd,i,1)
			i=i+1
		Wend
		i=i+1
		While Mid(strEd,i,1)<>","
			strHSIForm=strHSIForm & Mid(strEd,i,1)
			i=i+1
		Wend
		i=i+1
		While Mid(strEd,i,1)<>","
			strForm1=strForm1 & Mid(strEd,i,1)
			i=i+1
		Wend
		i=i+1
		While Mid(strEd,i,1)<>","
			strForm2=strForm2 & Mid(strEd,i,1)
			i=i+1
		Wend
		strForm3=Right(strEd,Len(strEd)-i)
		strVerb=Trim(strVerb)
		strHSIForm=Trim(strHSIForm)
		strForm1=Trim(strForm1)
		strForm2=Trim(strForm2)
		strForm3=Trim(strForm3)
		blAfter=False
		strAfter=""
		For i=1 To Len(strVerb)
			If Mid(strVerb,i,1)=" " Then
				blAfter=True
				strAfter=Right(strVerb,Len(strVerb)-i)
				strVerb=Left(strVerb,i-1)
				Exit For
			End If
		Next
		strAfter=Trim(strAfter)
		Instantiate=True
	End Function

	Function SpecialForm(intForm,intTime,blPositive)
		On Error Resume Next
		Dim strRes,str1,str2,str3
		Select Case intTime
			Case verbPrSimp
				If Not blPositive Then
					If intForm=verbHSI Then str1="doesn't " Else str1="don't "
					SpecialForm=str1 & strVerb
					Exit Function
				End If
				If intForm=verbHSI Then strRes=strHSIForm Else strRes=strVerb
			Case verbPrCont
				If intForm=verbI Then
					str1="am"
				ElseIf intForm=verbHSI Then
					str1="is"
				Else
					str1="are"
				End If
				If Not blPositive Then str1=str1 & " not"
				strRes=str1 & " " & strForm3
			Case verbPrPerf
				If blPositive Then
					If intForm=verbHSI Then str1="has" Else str1="have"
				Else
					If intForm=verbHSI Then str1="hasn't" Else str1="haven't"
				End If
				strRes=str1 & " " & strForm2
			Case verbPtSimp
				If Not blPositive Then str1="didn't " & strVerb Else str1=strForm1
				strRes=str1
			Case verbPtCont
				If (intForm=verbI) Or (intForm=verbHSI) Then str1="was" Else str1="were"
				If Not blPositive Then str2="n't " Else str2=""
				strRes=str1 & str2 & strForm3
			Case verbPtPerf
				If blPositive Then str1="had " Else str1="hadn't "
				strRes=str1 & strForm2
			Case verbFtSimp
				If blPositive Then str1="will " Else str1="won't "
				strRes=str1 & strVerb
			Case verbFtCont
				If blPostive Then str1="will be " Else str1="won't be "
				strRes=str1 & strForm3
			Case verbMust
				If blPositive Then str1="must " Else str1="mustn't "
				strRes=str1 & strVerb
			Case verbHaveTo
				If intForm=verbHSI Then
					If blPositive Then str1="has to " Else str1="doesn't have to "
				Else
					If blPositive Then str1="have to " Else str1="don't have to "
				End If
				strRes=str1 & strVerb
			Case verbCan
				If blPositive Then str1="can " Else str1="cannot "
				strRes=str1 & strVerb
			Case verbCould
				If blPositive Then str1="could " Else str1="couldn't "
				strRes=str1 & strVerb
			Case verbWdLikeTo
				If blPositive Then str1="would like to " Else str1="wouldn't like to "
				strRes=str1 & strVerb
			Case verbWantTo
				If intForm=verbHSI Then str1="s" Else str1=""
				strRes="want" & str1 & " to " & strVerb
		End Select
		SpecialForm=strRes
	End Function
End Class

Class Noun
	Dim strNoun
	Dim strPlural
	
	Function Instantiate(strParam)
		'format of noun: (n)<noun>,<plural>
		On Error Resume Next		

		Dim strEd,i
		strEd=Trim(strParam)
		i=4
		If Mid(strEd,2,1)<>"n" Then
			Instantiate=False
			Exit Function
		End If
		strNoun=""
		strPlural=""
		While Mid(strEd,i,1)<>","
			strNoun=strNoun & Mid(strEd,i,1)
			i=i+1
		Wend
		strPlural=Right(strEd,Len(strEd)-i)
		Instantiate=True
	End Function
End Class

Class Adverb
	Dim strAdverb
	'Dim strAdverbType

	Function Instantiate(strParam)
		'Adverb format: (adv)<adverb>
		On Error Resume Next

		Dim strEd
		strEd=Trim(strParam)
		If Mid(strEd,2,3)<>"adv" Then
			Instantiate=False
			Exit Function
		End If
		strAdverb=Right(strEd,Len(strEd)-5)
	End Function
End Class

'this is a sample of using this classes
'How to use?

Set b=New Verb
b.Instantiate("(vt)go out,goes,went,gone,going")
Set a=New Noun
a.Instantiate("(n)Asel,")
Set c=New Adverb
c.Instantiate("(adv)slowly")
Set s=New Sentence
s.Instantiate a,b,c,"",verbPrSimp,False
WScript.Echo s.Compose